package com.zcloud.service.emergency.impl;

import com.zcloud.entity.Page;
import com.zcloud.entity.PageData;
import com.zcloud.mapper.datasource.emergency.EmergencyPlanMapper;
import com.zcloud.service.emergency.EmergencyPlanService;
import com.zcloud.util.Smb;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * 说明：应急预案备案
 * 作者：luoxiaobao
 * 时间：2021-06-19
 * 官网：www.zcloudchina.com
 */
@Service
@Transactional //开启事物
public class EmergencyPlanServiceImpl implements EmergencyPlanService {

	@Autowired
	private EmergencyPlanMapper emergencyplanMapper;
	@Autowired
	private Smb smb;
	/**新增
	 * @param pd
	 * @throws Exception
	 */
	public void save(PageData pd)throws Exception{
		emergencyplanMapper.save(pd);
	}

	/**删除
	 * @param pd
	 * @throws Exception
	 */
	public void delete(PageData pd)throws Exception{
		PageData d = findById(pd);
		smb.deleteFile(d.getString("PLAN_ATTACH_IDS"));
		emergencyplanMapper.delete(pd);
	}

	/**修改
	 * @param pd
	 * @throws Exception
	 */
	public void edit(PageData pd)throws Exception{
		emergencyplanMapper.edit(pd);
	}

	/**列表
	 * @param page
	 * @throws Exception
	 */
	public List<PageData> list(Page page)throws Exception{
		return emergencyplanMapper.datalistPage(page);
	}

	/**列表(全部)
	 * @param pd
	 * @throws Exception
	 */
	public List<PageData> listAll(PageData pd)throws Exception{
		return emergencyplanMapper.listAll(pd);
	}

	/**通过id获取数据
	 * @param pd
	 * @throws Exception
	 */
	public PageData findById(PageData pd)throws Exception{
		return emergencyplanMapper.findById(pd);
	}

	/**批量删除
	 * @param pd
	 * @throws Exception
	 */
	public void deleteAll(PageData pd)throws Exception{
		List<PageData> pdList = emergencyplanMapper.findByIds(pd);
		for (PageData d : pdList) {
			smb.deleteFile(d.getString("PLAN_ATTACH_IDS"));
		}
		emergencyplanMapper.deleteAll(pd);
	}

}

